# OpenXG-UDM


OpenXG-UDM Arch
```
├── build:         Build directory, contains targets and object files generated by compilation of network functions. 
    ├── scripts:   Directory containing scripts for building network functions.
    ├── ext:       Directory containing pistache and the JSON library.
    └── UDM:       Directory containing object files generated by compilation of UDM network function. 
├── etc:           Directory containing the configuration file to be deployed for UDM.
└── src:           Source files of UDM.
    ├── udm_app:   UDM Procedures handling logic. 
    ├── common:    Common definitions for 3GPP specifications.
    ├── 5gaka:     algorithms for 5G-AKA authentication procedures.
    ├── asnlib:    asn library.
    ├── utils:     Common utilities.  .
    ├── model:     UDM service. 
    ├── api:       UDM service.
    └── impl:      UDM service.
```
    
## Download source code from Gitlab
```
git clone http://git.opensource5g.org/openxg/udm.git
cd openxg-udm/
git checkout master
```

## install dependencies
```
cd ./build/scripts
sudo ./build_udm -I
```
## build UDM
```
sudo ./build_udm -c -b Debug -j
```
## launch UDM
```
sudo ./build/UDM/udm -c etc/udm.conf -o
```
