/**
 * Nudm_UEAU
 * UDM UE Authentication Service. � 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 1.2.0-alpha.1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "ConfirmAuthApi.h"
#include "Helpers.h"

namespace oai {
namespace udm {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace oai::udm::model;

ConfirmAuthApi::ConfirmAuthApi(std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void ConfirmAuthApi::init() { setupRoutes(); }

void ConfirmAuthApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Post(*router, base + "/:supi/auth-events",
               Routes::bind(&ConfirmAuthApi::confirm_auth_handler, this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&ConfirmAuthApi::confirm_auth_api_default_handler, this));
}

void ConfirmAuthApi::confirm_auth_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto supi = request.param(":supi").as<std::string>();

  // Getting the body param

  AuthEvent authEvent;

  try {
    nlohmann::json::parse(request.body()).get_to(authEvent);
    this->confirm_auth(supi, authEvent, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void ConfirmAuthApi::confirm_auth_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace udm
} // namespace oai
