#ifndef _CONTEXTTONWDAFAPI_H_
#define _CONTEXTTONWDAFAPI_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include <string>

namespace oai {
namespace udm {
namespace api {

class ContextToNwdafApi {
public:
  ContextToNwdafApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~ContextToNwdafApi() {}
  void init();

  const std::string base = "/openxg";

private:
  void setupRoutes();

  void get_context_to_nwdaf_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);
  void context_to_nwdaf_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  virtual void get_context_to_nwdaf(      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace udm
} // namespace oai

#endif /* GroupIdentifiersApi_H_ */
