/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * GPSIToSUPITranslationApi.h
 *
 *
 */

#ifndef GPSIToSUPITranslationApi_H_
#define GPSIToSUPITranslationApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "IdTranslationResult.h"
#include "ProblemDetails.h"
#include <string>

namespace oai {
namespace udm {
namespace api {

using namespace oai::udm::model;

class GPSIToSUPITranslationApi {
public:
  GPSIToSUPITranslationApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~GPSIToSUPITranslationApi() {}
  void init();

  const std::string base = "/nudm-sdm/v2";

private:
  void setupRoutes();

  void get_supi_handler(const Pistache::Rest::Request &request,
                        Pistache::Http::ResponseWriter response);
  void gpsi_to_supi_translation_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// retrieve a UE&#39;s SUPI
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="gpsi">Identifier of the UE</param>
  /// <param name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param> <param name="ifNoneMatch">Validator for conditional
  /// requests, as described in RFC 7232, 3.2 (optional, default to
  /// &quot;&quot;)</param> <param name="ifModifiedSince">Validator for
  /// conditional requests, as described in RFC 7232, 3.3 (optional, default to
  /// &quot;&quot;)</param>
  virtual void get_supi(
      const std::string &gpsi,
      const Pistache::Optional<std::string> &supportedFeatures,
      const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch,
      const Pistache::Optional<Pistache::Http::Header::Raw> &ifModifiedSince,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace udm
} // namespace oai

#endif /* GPSIToSUPITranslationApi_H_ */
