/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "GroupIdentifiersApi.h"
#include "Helpers.h"

namespace oai {
namespace udm {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace oai::udm::model;

GroupIdentifiersApi::GroupIdentifiersApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void GroupIdentifiersApi::init() { setupRoutes(); }

void GroupIdentifiersApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Get(
      *router, base + "/group-data/group-identifiers",
      Routes::bind(&GroupIdentifiersApi::get_group_identifiers_handler, this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &GroupIdentifiersApi::group_identifiers_api_default_handler, this));
}

void GroupIdentifiersApi::get_group_identifiers_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {

  // Getting the query params
  auto extGroupIdQuery = request.query().get("ext-group-id");
  Pistache::Optional<std::string> extGroupId;
  if (!extGroupIdQuery.isEmpty()) {
    std::string value;
    if (fromStringValue(extGroupIdQuery.get(), value)) {
      extGroupId = Pistache::Some(value);
    }
  }
  auto intGroupIdQuery = request.query().get("int-group-id");
  Pistache::Optional<std::string> intGroupId;
  if (!intGroupIdQuery.isEmpty()) {
    std::string value;
    if (fromStringValue(intGroupIdQuery.get(), value)) {
      intGroupId = Pistache::Some(value);
    }
  }
  auto supportedFeaturesQuery = request.query().get("supported-features");
  Pistache::Optional<std::string> supportedFeatures;
  if (!supportedFeaturesQuery.isEmpty()) {
    std::string value;
    if (fromStringValue(supportedFeaturesQuery.get(), value)) {
      supportedFeatures = Pistache::Some(value);
    }
  }

  // Getting the header params
  auto ifNoneMatch = request.headers().tryGetRaw("If-None-Match");
  auto ifModifiedSince = request.headers().tryGetRaw("If-Modified-Since");

  try {
    this->get_group_identifiers(extGroupId, intGroupId, supportedFeatures,
                                ifNoneMatch, ifModifiedSince, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void GroupIdentifiersApi::group_identifiers_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace udm
} // namespace oai
