/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "RetrievalOfMultipleDataSetsApi.h"
#include "Helpers.h"

namespace oai {
namespace udm {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace oai::udm::model;

RetrievalOfMultipleDataSetsApi::RetrievalOfMultipleDataSetsApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void RetrievalOfMultipleDataSetsApi::init() { setupRoutes(); }

void RetrievalOfMultipleDataSetsApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Get(
      *router, base + "/:supi",
      Routes::bind(&RetrievalOfMultipleDataSetsApi::get_data_sets_handler,
                   this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&RetrievalOfMultipleDataSetsApi::
                       retrieval_of_multiple_data_sets_api_default_handler,
                   this));
}

void RetrievalOfMultipleDataSetsApi::get_data_sets_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto supi = request.param(":supi").as<std::string>();

  // Getting the query params
  auto datasetNamesQuery = request.query().get("dataset-names");
  Pistache::Optional<std::vector<std::string>> datasetNames;
  if (!datasetNamesQuery.isEmpty()) {
    std::vector<std::string> value;
    if (fromStringValue(datasetNamesQuery.get(), value)) {
      datasetNames = Pistache::Some(value);
    }
  }
  auto plmnIdQuery = request.query().get("plmn-id");
  Pistache::Optional<PlmnId> plmnId;
  /*    if(!plmnIdQuery.isEmpty()){
          PlmnId value;
          if(fromStringValue(plmnIdQuery.get(), value)){
              plmnId = Pistache::Some(value);
          }
      }
  */
  auto supportedFeaturesQuery = request.query().get("supported-features");
  Pistache::Optional<std::string> supportedFeatures;
  if (!supportedFeaturesQuery.isEmpty()) {
    std::string value;
    if (fromStringValue(supportedFeaturesQuery.get(), value)) {
      supportedFeatures = Pistache::Some(value);
    }
  }

  // Getting the header params
  auto ifNoneMatch = request.headers().tryGetRaw("If-None-Match");
  auto ifModifiedSince = request.headers().tryGetRaw("If-Modified-Since");

  try {
    this->get_data_sets(supi, datasetNames, plmnId, supportedFeatures,
                        ifNoneMatch, ifModifiedSince, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void RetrievalOfMultipleDataSetsApi::
    retrieval_of_multiple_data_sets_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace udm
} // namespace oai
