/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * SubscriptionModificationApi.h
 *
 *
 */

#ifndef SubscriptionModificationApi_H_
#define SubscriptionModificationApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ProblemDetails.h"
#include "SdmSubsModification.h"
#include "SdmSubscription.h"
#include <string>

namespace oai {
namespace udm {
namespace api {

using namespace oai::udm::model;

class SubscriptionModificationApi {
public:
  SubscriptionModificationApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~SubscriptionModificationApi() {}
  void init();

  const std::string base = "/nudm-sdm/v2";

private:
  void setupRoutes();

  void modify_handler(const Pistache::Rest::Request &request,
                      Pistache::Http::ResponseWriter response);
  void modify_shared_data_subs_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void subscription_modification_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// modify the subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="supi">SUPI of the user</param>
  /// <param name="subscriptionId">Id of the SDM Subscription</param>
  /// <param name="sdmSubsModification"></param>
  virtual void modify(const std::string &supi,
                      const std::string &subscriptionId,
                      const SdmSubsModification &sdmSubsModification,
                      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// modify the subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subscriptionId">Id of the SDM Subscription</param>
  /// <param name="sdmSubsModification"></param>
  virtual void
  modify_shared_data_subs(const std::string &subscriptionId,
                          const SdmSubsModification &sdmSubsModification,
                          Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace udm
} // namespace oai

#endif /* SubscriptionModificationApi_H_ */
