/**
* Nudm_UECM
* Nudm Context Management Service. � 2020, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/

#include "AMFRegistrationFor3GPPAccessApiImpl.h"
#include "udm_config.hpp"
#include "logger.hpp"
#include "curl.hpp"

using namespace config;
extern config::udm_config udm_cfg;

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

AMFRegistrationFor3GPPAccessApiImpl::AMFRegistrationFor3GPPAccessApiImpl(std::shared_ptr<Pistache::Rest::Router> rtr)
    : AMFRegistrationFor3GPPAccessApi(rtr)
    { }

void AMFRegistrationFor3GPPAccessApiImpl::xg_3gpp_registration(const std::string &ueId, const Amf3GppAccessRegistration &amf3GppAccessRegistration, Pistache::Http::ResponseWriter &response) {

  std::string udr_ip =
      std::string(inet_ntoa(*((struct in_addr *)&udm_cfg.nudr.addr4)));
  std::string udr_port = std::to_string(udm_cfg.nudr.port);
  std::string remoteUri;
  std::string Method;
  std::string msgBody;
  std::string Response;
  nlohmann::json j_ProblemDetails;
  ProblemDetails m_ProblemDetails;

  // UDR GET interface ----- get 3gpp_registration related info--------------------
  remoteUri = udr_ip + ":" + udr_port + "/nudr-dr/v2/subscription-data/" + ueId + "/context-data/amf-3gpp-access";
  Logger::udm_uecm().debug("PUT Request:" + remoteUri);
  Method = "PUT";

  nlohmann::json amf3GppAccessRegistration_j; 
  to_json(amf3GppAccessRegistration_j, amf3GppAccessRegistration);
  long http_code;
  http_code = Curl::curl_http_client(remoteUri, Method, amf3GppAccessRegistration_j.dump(), Response);

  nlohmann::json response_data = {};
  try {
    Logger::udm_uecm().debug("PUT Reponse:" + Response);
    response_data = nlohmann::json::parse(Response.c_str());

  } catch (nlohmann::json::exception &e) { // error handling
    Logger::udm_uecm().info("Could not get Json content from UDR response");

    m_ProblemDetails.setCause("USER_NOT_FOUND");
    m_ProblemDetails.setStatus(404);
    m_ProblemDetails.setDetail("User " + ueId + " not found in Database");
    to_json(j_ProblemDetails, m_ProblemDetails);

    Logger::udm_uecm().error("User " + ueId + " not found in Database");
    Logger::udm_uecm().info("Send 404 Not_Found response to client");
    response.send(Pistache::Http::Code::Not_Found, j_ProblemDetails.dump());
    return;
  }
  Logger::udm_uecm().debug("http reponse code %d. \n",http_code);
  response.send(static_cast<Pistache::Http::Code>(http_code), amf3GppAccessRegistration_j.dump());
}

}
}
}
}

