#include "ContextToNwdafApiImpl.hpp"

#include "context_udm.hpp"

#include <vector>
#include <nlohmann/json.hpp>

using namespace context;

extern context_udm *udm_context;

namespace oai {
namespace udm {
namespace api {


ContextToNwdafApiImpl::ContextToNwdafApiImpl(
    std::shared_ptr<Pistache::Rest::Router> rtr)
    : ContextToNwdafApi(rtr) {}

void ContextToNwdafApiImpl::get_context_to_nwdaf(Pistache::Http::ResponseWriter &response) {
  //response.send(Pistache::Http::Code::Ok, "Do some magic\n");
  std::vector < imsi_context > list;
  udm_context->get_udm_context(list);

  nlohmann::json j, tmp_j;
  if(list.size() > 0)
  {
    for(int i=0;i<list.size();i++)
    {
      to_json(tmp_j, list[i]);
      j += tmp_j;
    }

    response.send(Pistache::Http::Code::Ok, j.dump());
  }
  else
  {
    response.send(Pistache::Http::Code::Ok, "[]");
  }



//  std::string out = j.dump();
//  Logger::udr_server().debug("AuthenticationSubscription PATCH - json:\n\"%s\"",out.c_str());
}

} // namespace api
} // namespace udm
} // namespace oai

