/**
 * Nudm_SDM
 * Nudm Subscriber Data Management Service. � 2019, 3GPP Organizational Partners
 * (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.0.alpha-1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "SessionManagementSubscriptionDataRetrievalApiImpl.h"
#include "SessionManagementSubscriptionData.h"
#include <nlohmann/json.hpp>

#include "udm_config.hpp"
#include "logger.hpp"
#include "curl.hpp"

using namespace config;
extern config::udm_config udm_cfg;


namespace oai {
namespace udm {
namespace api {

using namespace oai::udm::model;

SessionManagementSubscriptionDataRetrievalApiImpl::
    SessionManagementSubscriptionDataRetrievalApiImpl(
        std::shared_ptr<Pistache::Rest::Router> rtr)
    : SessionManagementSubscriptionDataRetrievalApi(rtr) {}

// void SessionManagementSubscriptionDataRetrievalApiImpl::get_sm_data(const
// std::string &supi, const Pistache::Optional<std::string> &supportedFeatures,
// const Pistache::Optional<Snssai> &singleNssai, const
// Pistache::Optional<std::string> &dnn, const Pistache::Optional<PlmnId>
// &plmnId, const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch,
// const Pistache::Optional<Pistache::Http::Header::Raw> &ifModifiedSince,
// Pistache::Http::ResponseWriter &response) {
void SessionManagementSubscriptionDataRetrievalApiImpl::get_sm_data(
    const std::string &supi, const Pistache::Optional<Snssai> &singleNssai,
    const Pistache::Optional<std::string> &dnn,
    Pistache::Http::ResponseWriter &response) {
#if 0
  std::cout
      << "Received a SessionManagementSubscriptionDataRetrieval with supi "
      << supi.c_str() << std::endl;
  /*
   {
     "singleNssai": {"sst":1, "sd":123},
     "dnnConfigurations": {
        "default":  {
           "pduSessionTypes": {"defaultSessionType": "IPV4"} ,
           "sscModes": {"defaultSscMode": "SSC_MODE_1"} ,
           "5gQosProfile":  {"5qi": 12345, "arp": {"priorityLevel": 1 ,
  "preemptCap": "NOT_PREEMPT" , "preemptVuln": "NOT_PREEMPTABLE"} },
           "sessionAmbr": {"uplink": "10Mbps", "downlink":"11Mbps"}
        }
     }
  }
   */
  nlohmann::json jsonData;
  jsonData["singleNssai"]["sst"] = 222;
  jsonData["singleNssai"]["sd"] = 123;
  jsonData["dnnConfigurations"]["internet"]["pduSessionTypes"]
          ["defaultSessionType"] = "IPV4";
  jsonData["dnnConfigurations"]["internet"]["sscModes"]["defaultSscMode"] =
      "SSC_MODE_1";
  jsonData["dnnConfigurations"]["internet"]["5gQosProfile"]["5qi"] = 1;
  jsonData["dnnConfigurations"]["internet"]["5gQosProfile"]["arp"]
          ["priorityLevel"] = 1;
  jsonData["dnnConfigurations"]["internet"]["5gQosProfile"]["arp"]
          ["preemptCap"] = "NOT_PREEMPT";
  jsonData["dnnConfigurations"]["internet"]["5gQosProfile"]["arp"]
          ["preemptVuln"] = "NOT_PREEMPTABLE";
  jsonData["dnnConfigurations"]["internet"]["sessionAmbr"]["uplink"] =
      "2000Mbps";
  jsonData["dnnConfigurations"]["internet"]["sessionAmbr"]["downlink"] =
      "1000Mbps";

  /*
          SessionManagementSubscriptionData subscriptionData;
          subscriptionData.setSingleNssai(singleNssai.get());

          DnnConfiguration dnnConfiguration;
          PduSessionTypes pduSessionTypes;
      SscModes sscModes;
      SubscribedDefaultQos qosProfile;
      Ambr sessionAmbr;

      pduSessionTypes.setDefaultSessionType(PduSessionType(PduSessionType_e::PDU_SESSION_TYPE_E_IPV4));
          dnnConfiguration.setPduSessionTypes(pduSessionTypes);
          sscModes.setDefaultSscMode(SscMode(SscMode_e::SSC_MODE_1));
          dnnConfiguration.setSscModes(sscModes);
  */

  // Send reply to SMF
  std::string resBody = jsonData.dump();
  // httpResponse.headers().add<Pistache::Http::Header::Location>(url);
  response.send(Pistache::Http::Code::Ok, resBody);
#endif

    // 1. populate remote uri for udp request
    std::string udr_ip = std::string(inet_ntoa(*((struct in_addr *)&udm_cfg.nudr.addr4)));
    std::string udr_port = std::to_string(udm_cfg.nudr.port);
    //std::string remote_uri = udr_ip + ":" + udr_port + "/nudr-dr/v2/subscription-data/"+supi+plmnId+"/provisioned-data/am-data";
    std::string remote_uri = udr_ip + ":" + udr_port + "/nudr-dr/v2/subscription-data/"+supi+"/456789/provisioned-data/sm-data";

    std::string method("GET");
    std::string body("");
    std::string response_get;
    Logger::udm_sdm().debug("UDR: GET Request: "+ remote_uri);
    // 2. invoke curl to get response from udr
    long http_code = Curl::curl_http_client(remote_uri, method, body, response_get);
    // 3. process response
    nlohmann::json response_data_json = {};
    try {
            Logger::udm_sdm().debug("subscription-data: GET Response: "+response_get);
            response_data_json = nlohmann::json::parse(response_get.c_str());
        } catch (nlohmann::json::exception &e) {
                 Logger::udm_sdm().info("Could not get json content from UDR response");
                 ProblemDetails problem_details;
                 nlohmann::json json_problem_details;
                 problem_details.setCause("USER_NOT_FOUND");
                 problem_details.setStatus(404);
                 problem_details.setDetail("User " + supi + " not found in Database");                 
                 to_json(json_problem_details, problem_details);
                 Logger::udm_sdm().error("User " + supi + " not found in Database");
                 Logger::udm_sdm().info("Send 404 Not_Found response to client");
                 response.send(Pistache::Http::Code::Not_Found, json_problem_details.dump());
                 return;
          }
    Logger::udm_sdm().debug("http reponse code %d.\n",http_code);
    response.send(static_cast<Pistache::Http::Code>(http_code), response_data_json.dump());

}

} // namespace api
} // namespace udm
} // namespace oai
