#include "context_udm.hpp"

//using namespace context;

namespace context {

context_udm::context_udm(){}
context_udm::~context_udm(){}

//------------------------------------------------------------------------------
bool context_udm::is_imsi_2_udm_context(    const std::string &imsi) const {
  std::shared_lock lock(m_imsicontext);

  return bool{imsicontext.count(imsi) > 0};
}

//------------------------------------------------------------------------------
void context_udm::set_imsi_2_udm_context(const std::string &imsi, std::shared_ptr<imsi_context> ic) {
  std::shared_lock lock(m_imsicontext);

  imsicontext[imsi] = ic;
}

//------------------------------------------------------------------------------
std::shared_ptr<imsi_context> context_udm::imsi_2_udm_context(const std::string &imsi) {
  std::shared_lock lock(m_imsicontext);

  return imsicontext.at(imsi);;
}

//------------------------------------------------------------------------------
bool context_udm::get_udm_context(std::vector<imsi_context> &vec) {
  std::shared_lock lock(m_imsicontext);

  std::map<std::string, std::shared_ptr<imsi_context>>::reverse_iterator   iter;
  for(iter = imsicontext.rbegin(); iter != imsicontext.rend(); iter++)
  {
    vec.push_back(*(iter->second.get()));
  }

  return true;
}

}

