#ifndef _CONTEXT_UDM_H_
#define _CONTEXT_UDM_H_

#include <map>
#include <memory>
#include <shared_mutex>

#include "imsi_context.hpp"

namespace context {

class context_udm{
public:
    context_udm();
    virtual ~context_udm();

    bool is_imsi_2_udm_context(const std::string &imsi) const;
    void set_imsi_2_udm_context(const std::string &imsi, std::shared_ptr<imsi_context> ic);

    std::shared_ptr<imsi_context> imsi_2_udm_context(const std::string &imsi);
    bool get_udm_context(std::vector<imsi_context> &vec);

private:
    std::map<std::string, std::shared_ptr<imsi_context>> imsicontext;
    mutable std::shared_mutex m_imsicontext;
};
}

#endif