/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */

/*! file
brief
author Jian Yang
date 2021
email: contact@openairinterface.org
*/

#ifndef _IMSI_CONTEXT_H_
#define _IMSI_CONTEXT_H_

#include <nlohmann/json.hpp>
#include <string>

namespace context {
// imsi、Opc、OpType、K、鉴权
class imsi_context {
 public:
  imsi_context();
  virtual ~imsi_context();

  bool getMessageFlag() const;
  void setMessageFlag(bool const& value);

  std::string getImsi() const;
  void setImsi(std::string const& value);
  bool imsiIsSet() const;
  void unsetImsi();

  std::string getOp() const;
  void setOp(std::string const& value);
  bool opIsSet() const;
  void unsetOp();

  std::string getOpType() const;
  void setOpType(std::string const& value);
  bool opTypeIsSet() const;
  void unsetOpType();

  std::string getK() const;
  void setK(std::string const& value);
  bool kIsSet() const;
  void unsetK();

  friend void to_json(nlohmann::json& j, const imsi_context& o);
  friend void from_json(const nlohmann::json& j, imsi_context& o);

 protected:
  bool m_messageFlag;
  std::string m_imsi;
  bool m_imsiIsSet;
  std::string m_op;
  bool m_opIsSet;
  std::string m_optype;
  bool m_optypeIsSet;
  std::string m_k;
  bool m_kIsSet;
};

}  // namespace nf_msg

#endif